########################################################################################################
##						zCivics						      ##
##												      ##
##	Created By:		Zebra 9								      ##
##	Created:		5 / 21 / 07							      ##
########################################################################################################

from CvPythonExtensions import *

# globals
gc = CyGlobalContext()

class zCivics:
	def __init__(self):
		self.lockInfo = dict()
		self.religionInfo = dict()
		self.unitInfo = dict()
		self.buildingInfo = dict()
		self.civInfo = dict()
		self.leaderInfo = dict()
		self.civicInfo = dict()

########################################################################################################
################			Add Your Code Below Here			################
########################################################################################################
		self.addCivicPre("CIVIC_SLAVERY", "CIVIC_BARBARISM")
########################################################################################################
################			Change Nothing Below Here			################
########################################################################################################

	def addReligionPre(self, szCivic, szReligion):
		if not self.religionInfo.has_key(szReligion):
			self.religionInfo[szReligion] = list()
		self.religionInfo[szReligion].append(szCivic)

	def addUnitPre(self, szUnit, szCivic):
		if not self.unitInfo.has_key(szUnit):
			self.unitInfo[szUnit] = list()
		self.unitInfo[szUnit].append(szCivic)

	def addBuildingPre(self, szBuilding, szCivic):
		if not self.buildingInfo.has_key(szBuilding):
			self.buildingInfo[szBuilding] = list()
		self.buildingInfo[szBuilding] = szCivic

	def addLockCivic(self, szCivic):
		if not self.lockInfo.has_key(szCivic):
			self.lockInfo[szCivic] = list()
		self.lockInfo[szCivic] = True

	def addCivBlock(self, szCivic, szCivName):
		if not self.civInfo.has_key(szCivName):
			self.civInfo[szCivName] = list()
		self.civInfo.append(szCivic)

	def addLeaderBlock(self, szCivic, szLeaderName):
		if not self.leaderInfo.has_key(szLeaderName):
			self.leaderInfo[szLeaderName] = list()
		self.leaderInfo[szLeaderName].append(szCivic)

	def addCivicPre(self, szCivic, szCivicName):
		if not self.civicInfo.has_key(szCivic):
			self.civicInfo[szCivic] = list()
		self.civicInfo[szCivic].append(szCivicName)

	def cannotDoCivic(self, iPlayer, iCivic):
		civicType = gc.getCivicInfo(iCivic).getType()

		## See if iPlayer's state religion blocks iCivic
		if gc.getPlayer(iPlayer).getStateReligion() >= 0:
			szReligionType = gc.getReligionInfo(gc.getPlayer(iPlayer).getStateReligion()).getType()
		else:
			szReligionType = "RELIGION_NO_State"
		if self.religionInfo.has_key(civicType):
			if szReligionType in self.religionInfo[civicType]:
				return True

		## See if iPlayer's current Civic choice blocks all civics of the same civic opt group
		pPlayer = gc.getPlayer(iPlayer)
		civicOptType = gc.getCivicInfo(iCivic).getCivicOptionType()
		testCivic = gc.getCivicInfo(pPlayer.getCivics(civicOptType)).getType()
		if self.lockInfo.has_key(testCivic) and testCivic != civicType:
			if self.lockInfo[testCivic]:
				return True

		## Check to see if iPlayer's civ type blocks iCivic
		szCivType = gc.getCivilizationInfo(pPlayer.getCivilizationType()).getType()
		if self.civInfo.has_key(szCivType):
			if civicType in self.civInfo[szCivType]:
				return True

		## Check to see if iPlayer's leader blocks iCivic
		szLeaderType = gc.getLeaderHeadInfo(pPlayer.getLeaderType()).getType()
		if self.leaderInfo.has_key(szLeaderType):
			if civicType in self.leaderInfo[szLeaderType]:
				return True

		## Check to see if iPlayer's civic selection blocks iCivic
		if self.civicInfo.has_key(civicType):
			for szCivic in range(len(self.civicInfo[civicType])):
				if not pPlayer.isCivic(gc.getInfoTypeForString(self.civicInfo[civicType][szCivic])):
					return True
		return False

	def cannotTrainUnit(self, iPlayer, iUnit):
		unitType = gc.getUnitInfo(iUnit).getType()
		if self.unitInfo.has_key(unitType):
			if not gc.getPlayer(iPlayer).isCivic(gc.getInfoTypeForString(self.unitInfo[unitType])):
				return True
		return False

	def cannotConstructBuilding(self, iPlayer, iBuilding):
		buildingType = gc.getBuildingInfo(iBuilding).getType()
		if self.buildingInfo.has_key(buildingType):
			if not gc.getPlayer(iPlayer).isCivic(gc.getInfoTypeForString(self.buildingInfo[buildingType])):
				return True
		return False